"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:libview' }"

Object subclass:#Workstation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Graphics'
!

!Workstation class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    this class is only here, to find out which GraphicsDevice should
    be used by default and set the global variables Screen and the default
    display in DeviceWorkstation.

    [author:]
        Claus Gittinger
"
! !

!Workstation class methodsFor:'initialization'!

initialize
    |wsClass workstationType altWorkstationType|

    "
     initialize the default Screen and display - this must be done only once
    "
    Screen isNil ifTrue:[

        "
         figure out, which display class to use
         (if multiple have been bound into the system)
        "

        "
         if there is a GL-XWorkstation, use it
        "
        (wsClass := Smalltalk at:#OpenGLWorkstation) notNil ifTrue:[
            workstationType := wsClass.
        ] ifFalse:[
            (wsClass := Smalltalk at:#GLXWorkstation) notNil ifTrue:[
                workstationType := wsClass.
            ] ifFalse:[
                workstationType := XWorkstation
            ]
        ].

        workstationType notNil ifTrue:[
            "
             make sure its initialized ...
            "
            workstationType initialize.
        ].

        "
         preparation for NeXTStep/OS2 and Mac interfacing;
         and handle WIN32 interface.
         But if X is linked in and it capable of setting up a connection,
         that will be used.
        "
        #(
            "/ #NeXTWorkstation  nil
            #OS2Workstation   isOS2like
            #MacWorkstation   isMAClike
            #WinWorkstation   isMSWINDOWSlike
        ) pairWiseDo:[:wsClassName :checkSel |
            (checkSel isNil or:[OperatingSystem perform:checkSel]) ifTrue:[
                (wsClass := Smalltalk at:wsClassName) notNil ifTrue:[
                    wsClass initialize.

                    workstationType isNil ifTrue:[
                        workstationType := wsClass
                    ] ifFalse:[
                        altWorkstationType := wsClass
                    ]
                ]
            ].
        ].


        workstationType notNil ifTrue:[
            Display isNil ifTrue:[
                Smalltalk isHeadless ifFalse:[
                    Display := workstationType basicNew initializeFor:nil.
                    "/ try alternative, if that did not work.
                    (Display isNil and:[altWorkstationType notNil]) ifTrue:[
                        Display := altWorkstationType basicNew initializeFor:nil.
                    ].
                ].
            ].
            "
             if we found any display, make it the default.
            "
            Display notNil ifTrue:[
                MainDisplay := Display.
                DeviceWorkstation default:Display.
                DisplayRootView initialize.
                Screen := Display class.
            ] ifFalse:[
                Screen := workstationType
            ].
        ] ifFalse:[
            'Workstation [warning]: no concrete Display class built in' infoPrintCR.
            Screen := DeviceWorkstation.
        ].
    ]

    "Modified: / 10.1.1997 / 15:12:33 / cg"
    "Modified: / 27.10.1999 / 12:59:31 / stefan"
!

reinitialize
    "reinitialize after a snapin."

    "
     this code will eventually handle the case where we come up
     on another type of workstation. For now, images saved while running
     on X will not work properly on some other device.
    "
    Display notNil ifTrue:[
	Display reinitialize.
    ]
! !

!Workstation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/Workstation.st,v 1.30 2000-11-02 10:46:24 stefan Exp $'
! !
Workstation initialize!
